
CC=gcc

CFLAGS=-I../src/ `sdl2-config --cflags` `sdl2-config --libs` -lstdc++ -fopenmp -std=c++11 -lm -O3 -g

SRC=../src/utils.cpp ../src/Box.cpp ../src/Camera.cpp ../src/Light.cpp ../src/Mat.cpp \
	../src/Material.cpp ../src/Mesh.cpp ../src/RayTracer.cpp \
	../src/Scene.cpp ../src/Sphere.cpp ../src/Surface.cpp \
	../src/Transform.cpp ../src/Triangle.cpp ../src/Vertex.cpp \
	../src/BillboardTransform.cpp ../src/Billboard.cpp ../src/BVH.cpp 

SRC_OBJ=$(SRC:%.cpp=%.o)

all: hello_world shading universe cube textures earth transforms exercise cube_motion humanoids airplane marble complex city indoors

sphere: $(SRC_OBJ) sphere.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

indoors: $(SRC_OBJ) indoors.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

city: $(SRC_OBJ) city.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

hello_world: $(SRC_OBJ) hello_world.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

shading: $(SRC_OBJ) shading.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

universe: $(SRC_OBJ) universe.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

cube: $(SRC_OBJ) cube.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

textures: $(SRC_OBJ) textures.cpp
	$(CC) -o $@.out $^ $(CFLAGS)

earth: $(SRC_OBJ) earth.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

transforms: $(SRC_OBJ) transforms.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

exercise: $(SRC_OBJ) exercise.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

cube_motion: $(SRC_OBJ) cube_motion.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

humanoids: $(SRC_OBJ) humanoids.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

airplane: $(SRC_OBJ) airplane.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

marble: $(SRC_OBJ) marble.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

complex: $(SRC_OBJ) complex.cpp 
	$(CC) -o $@.out $^ $(CFLAGS)

ifdef DEFINE
%.o: %.cpp
	$(CC) -D${DEFINE} -c -o $@ $^ $(CFLAGS)
else
%.o: %.cpp
	$(CC) -c -o $@ $^ $(CFLAGS)
endif

clean:
	rm *.out
	rm ../src/*.o
